﻿using UnityEngine;
using System.Collections;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class Note : MonoBehaviour {

	public float timeToFade;
	public GameObject nextRing;
	public bool activated = false;
	public bool firstNote;
	public bool lastNote;
	public AudioSource music;
	public Text bravo;

	private float timeSinceSpawn = 0f;
	private float alphaToSet = 1f;
	private float alphaText = 0f;
	private SpriteRenderer sprite;
	private float offset = 0.7f;
	private float errorMargin = 0.23f;

	private bool clicked = false;
	private float timeClicked;
	private float timeActivated;
	private bool safe;

	// Use this for initialization
	void Start () {
		sprite = gameObject.GetComponent<SpriteRenderer> ();
	}

	// Update is called once per frame
	void Update () {
		if(Input.GetKey(KeyCode.Escape)){
			Application.Quit ();
		}
		if (clicked) {
			timeClicked += Time.deltaTime;
		}
		if (activated) {
			timeActivated += Time.deltaTime;
			if (((clicked && timeClicked > errorMargin) || (!clicked && timeActivated > errorMargin)) && !safe) {
				SceneManager.LoadScene (0);
				// #fail
			} else if (clicked) {
				safe = true;
			}
			//if (timeSinceSpawn <= timeToFade) { //TODO weghalen aan het eind!!!!!!
				Vector3 scale = transform.localScale;
				scale.x += Time.deltaTime;
				scale.y += Time.deltaTime;
				scale.z += Time.deltaTime;
				transform.localScale = scale;
			//}

			timeSinceSpawn += Time.deltaTime;

			if (timeSinceSpawn + offset >= timeToFade && !lastNote) {
				nextRing.SetActive (true);
			}

			if (timeSinceSpawn >= timeToFade) {
				if (!lastNote) {
					nextRing.GetComponent<Note> ().activate ();
					alphaToSet -= Time.deltaTime;

					sprite.color = new Color (1, 1, 1, alphaToSet);

					if (alphaToSet <= 0) {
						Destroy (gameObject);
					}
				} else {
					//Conglaturations
					alphaToSet -= Time.deltaTime;
					sprite.color = new Color (1, 1, 1, alphaToSet);
					alphaText += Time.deltaTime;
					bravo.color = new Color (1, 1, 1, alphaText);
					if (alphaToSet <= 0) {
						Destroy (gameObject);
					}
				}
			}
		}
	}

	void OnMouseDown(){
		clicked = true;
		GetComponent<CircleCollider2D> ().enabled = false;
		if (firstNote) {
			activate ();
			music.Play ();
		}
	}

	public void activate(){
		activated = true;
	}
}
